#include "cdictionaryinttoint.h"
#include <iostream>
CDictionaryIntToInt::CDictionaryIntToInt(){};
int CDictionaryIntToInt::find(int key, bool soft) const{return this->key.find(key,soft);}
int CDictionaryIntToInt::get(int key)const{return this->val.get(find(key));}
bool CDictionaryIntToInt::add(int key, int val, char force) {
    if (!force && find(key, true) != -1) {if (force==2) return false;throw std::runtime_error("Key already registered");}
    this->key.append(key);
    this->val.append(val);
    total++;
    return true;
}

CDictionaryIntToInt::CDictionaryIntToInt(int key,int val) {this->add(key,val);}
bool CDictionaryIntToInt::remove(int key){key=this->find(key);if (key==-1)return 0;total--;this->key.remove(key);this->val.remove(key);return 1;};
void CDictionaryIntToInt::removepos(int pos){total--;this->key.remove(pos);this->val.remove(pos);};
//CDictionaryIntToInt::CDictionaryIntToInt(CDictionaryIntToInt&& other)noexcept{*this=other;other.~CDictionaryIntToInt();other.total=0;}
CDictionaryIntToInt::CDictionaryIntToInt(const CDictionaryIntToInt& other){
    for(int i=0;i<other.total;i++) {
    this->add(other.key.get(i),other.val.get(i),1);}
}
int CDictionaryIntToInt::gettotal()const{return total;}
CDictionaryIntToInt CDictionaryIntToInt::operator+(const CDictionaryIntToInt& other)const{
    if (total==0)
        return other;
    CDictionaryIntToInt returnme(other);
    for (int i=0;i<total;i++){
        int key=this->key.get(i);
        if (other.find(key,1)==-1)returnme.add(key,this->val.get(i));
    }
    return returnme;
}
CDictionaryIntToInt CDictionaryIntToInt::operator-(const CDictionaryIntToInt& other)const{
    CDictionaryIntToInt returnme(*this);
    for (int i=0;i<returnme.total;i++)
        if (other.find(returnme.key.get(i),1)!=-1){returnme.removepos(i);i--;}
    return returnme;
}
CDictionaryIntToInt& CDictionaryIntToInt::operator=(const CDictionaryIntToInt& other) {if (this==&other)return *this;
    key.~OnewayList();val.~OnewayList();total=0;
    for (int i = 0; i < other.total; i++) {
        this->add(other.key.get(i), other.val.get(i), true);
    }
    return *this;
}
// CDictionaryIntToInt CDictionaryIntToInt::operator/(const CDictionaryIntToInt& other)const{
//     CDictionaryIntToInt returnme(*this);//значення з першого
//     for (int i=0;i<returnme.total;i++)
//         if (other.find(returnme.key.get(i))==-1){returnme.removepos(i);i--;}
//     return returnme;
// }
bool CDictionaryIntToInt::operator==(const CDictionaryIntToInt& other)const{
    if (this==&other)return true;
    if (total!=other.total)return false;
    // std::cout<<*this<<other;
    for (int i=0;i<total;i++)
        if(other.get(this->key.get(i))!=this->val.get(i))return false;
    return true;}
// CDictionaryIntToInt CDictionaryIntToInt::operator/(const CDictionaryIntToInt& other)const{
//     CDictionaryIntToInt returnme;
//     for (int i=0;i<total;i++){
//         int otherkey=other.key.find(key.get(i));
//         if (otherkey==-1)continue;
//         if(other.val.get(otherkey)==val.get(i))returnme.add(key.get(i),val.get(i),true);}
//     return returnme;}
std::istream& operator>>(std::istream& in, CDictionaryIntToInt& dict) {
    int key, value;
    char buf[10];
    while (in >> buf) {
//        try {
            for (char i=0; i<10; i++) {
                if (!buf[i]) break;
                if ((buf[i] > 57||buf[i]<48)&&buf[i]!=32)
                    throw std::runtime_error("Non-number was entered");
            }
            key = atoi(buf);
            if (!(in >> value)) {
                throw std::runtime_error("Wrong pair was entered");
            }
        // } catch (const std::exception& e) {
        //     std::cerr << "Warning: " << e.what() << " Ignoring." << std::endl;
        //     in.clear();
        //     break;
        // }
            if (!dict.add(key, value)) {
                throw std::runtime_error(std::string("key \"") + std::to_string(key) + "\" was input before");
            }
    }
    return in;
}
std::ostream& operator<<(std::ostream& out, const CDictionaryIntToInt& dict) {
    if (!dict.total)throw std::runtime_error("Trying to output an empty list");
    for (int i=0;i<dict.total;i++)out<<dict.key.get(i)<<"->"<<dict.val.get(i)<<std::endl;
    return out;
}
